VERSION=0.4.2
#arg Installation prefix
PREFIX=/usr/local

CC=gcc
CFLAGS=-std=c99 -pedantic -Iinclude -DRPD_VERSION=\"$(VERSION)\"
CXX=c++
CXXFLAGS=-pedantic -Iinclude
CXXSTD=-ansi
LDFLAGS=

#flag Debug mode
DEBUG ?= 0
ifneq ($(DEBUG), 0)
	CFLAGS+=-Wall -g -DDEBUG_MODE
	CXXFLAGS+=-Wall -g -DDEBUG_MODE
else
	CFLAGS+=-O3
	CXXFLAGS+=-O3
endif

#flag Add TCP server
TCP_SERVER ?= 1
ifeq ($(TCP_SERVER), 1)
	LDFLAGS += -lmongoose
endif

#flag Add FastCGI server
FCGI_SERVER ?= 1
ifeq ($(FCGI_SERVER), 1)
	LDFLAGS += -lfcgi
endif

#flag Multithread support
MT_ENABLED ?= 0
#arg Number of threads. 8 by default.
NTHREADS = 8
ifneq ($(MT_ENABLED), 0)
	CXXFLAGS+=-DMT_ENABLED -DNTHREADS=$(NTHREADS)
	CFLAGS+=-DMT_ENABLED -DNTHREADS=$(NTHREADS)
	LDFLAGS+=-lpthread
endif
