/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright 2022 Ivan Polyakov */

/*!
 * \file fcgi.h
 * \brief Rapida FastCGI server
 */
#ifndef RAPIDA_SERVERS_FCGI_H_ENTRY
#define RAPIDA_SERVERS_FCGI_H_ENTRY

#include "../app.h"
#include <fcgiapp.h>

#ifdef __cplusplus
extern "C" {
#endif

/*!
 * \brief Starts Rapida FastCGI server.
 * \param app Application instance.
 * \param sock_path UNIX Socket path.
 *
 * \return Status. 0 is success.
 */
int rpd_fcgi_server_start(rpd_app *app, const char *sock_path);

#ifdef __cplusplus
}
#endif

#endif /* RAPIDA_SERVERS_FCGI_H_ENTRY */
