/* SPDX-License-Identifier: GPL-3.0-or-later */
/* Copyright 2022 Ivan Polyakov */

/*!
 * \file tcp.h
 * \brief Rapida TCP server
 */
#ifndef RAPIDA_SERVERS_TCP_H_ENTRY
#define RAPIDA_SERVERS_TCP_H_ENTRY

#include "../app.h"

#ifdef __cplusplus
extern "C" {
#endif

/*!
 * \brief Starts Rapida TCP server.
 * \param app Application instance.
 * \param addr URL address to listen.
 *
 * \return Status. 0 is success.
 */
int rpd_tcp_server_start(rpd_app *app, const char *addr);

#ifdef __cplusplus
}
#endif

#endif /* RAPIDA_SERVERS_TCP_H_ENTRY */
